Index: src/loaddtdschema-postgres.sql
===================================================================
--- src/loaddtdschema-postgres.sql	(nonexistent)
+++ src/loaddtdschema-postgres.sql	(revision 4080)
@@ -0,0 +1,50 @@
+DELETE FROM xml_catalog 
+      WHERE entry_type LIKE 'DTD'
+        AND public_id LIKE '%@eml-version@%';
+DELETE FROM xml_catalog 
+      WHERE entry_type LIKE 'Schema'
+        AND system_id LIKE '%eml%';
+INSERT INTO xml_catalog (entry_type, public_id, system_id)
+  VALUES ('DTD', '-//ecoinformatics.org//eml-access-@eml-version@//EN',
+         '/dtd/eml-access-@eml-version@.dtd');
+INSERT INTO xml_catalog (entry_type, public_id, system_id)
+  VALUES ('DTD', '-//ecoinformatics.org//eml-attribute-@eml-version@//EN',
+          '/dtd/eml-attribute-@eml-version@.dtd');
+INSERT INTO xml_catalog (entry_type, public_id, system_id)
+  VALUES ('DTD', '-//ecoinformatics.org//eml-constraint-@eml-version@//EN',
+          '/dtd/eml-constraint-@eml-version@.dtd');
+INSERT INTO xml_catalog (entry_type, public_id, system_id)
+  VALUES ('DTD', '-//ecoinformatics.org//eml-coverage-@eml-version@//EN',
+          '/dtd/eml-coverage-@eml-version@.dtd');
+INSERT INTO xml_catalog (entry_type, public_id, system_id)
+  VALUES ('DTD', '-//ecoinformatics.org//eml-dataset-@eml-version@//EN',
+          '/dtd/eml-dataset-@eml-version@.dtd');
+INSERT INTO xml_catalog (entry_type, public_id, system_id)
+  VALUES ('DTD', '-//ecoinformatics.org//eml-entity-@eml-version@//EN',
+          '/dtd/eml-entity-@eml-version@.dtd');
+INSERT INTO xml_catalog (entry_type, public_id, system_id)
+  VALUES ('DTD', '-//ecoinformatics.org//eml-literature-@eml-version@//EN',
+          '/dtd/eml-literature-@eml-version@.dtd');
+INSERT INTO xml_catalog (entry_type, public_id, system_id)
+  VALUES ('DTD', '-//ecoinformatics.org//eml-physical-@eml-version@//EN',
+          '/dtd/eml-physical-@eml-version@.dtd');
+INSERT INTO xml_catalog (entry_type, public_id, system_id)
+  VALUES ('DTD', '-//ecoinformatics.org//eml-project-@eml-version@//EN',
+          '/dtd/eml-project-@eml-version@.dtd');
+INSERT INTO xml_catalog (entry_type, public_id, system_id)
+  VALUES ('DTD', '-//ecoinformatics.org//eml-protocol-@eml-version@//EN',
+          '/dtd/eml-protocol-@eml-version@.dtd');
+INSERT INTO xml_catalog (entry_type, public_id, system_id)
+  VALUES ('DTD', '-//ecoinformatics.org//eml-software-@eml-version@//EN',
+          '/dtd/eml-software-@eml-version@.dtd');
+INSERT INTO xml_catalog (entry_type, public_id, system_id)
+  VALUES ('Schema', '@eml2_0_1namespace@', '/schema/eml-2.0.1/eml.xsd');
+INSERT INTO xml_catalog (entry_type, public_id, system_id)
+  VALUES ('Schema', '@eml2_0_0namespace@', '/schema/eml-2.0.0/eml.xsd');
+INSERT INTO xml_catalog (entry_type, public_id, system_id)
+  VALUES ('Schema', '@stmmlnamespace@', '/schema/eml-2.0.1/stmml.xsd');
+INSERT INTO xml_catalog (entry_type, public_id, system_id)
+  VALUES ('Schema', 'metadata', '/schema/fgdc-std-001/fgdc-std-001-1998.xsd');
+
+INSERT INTO db_version (version, status, date_created) 
+  VALUES ('1.9.0',1,CURRENT_DATE);

Index: src/edu/ucsb/nceas/metacat/DBValidate.java
===================================================================
--- src/edu/ucsb/nceas/metacat/DBValidate.java	(revision 4079)
+++ src/edu/ucsb/nceas/metacat/DBValidate.java	(revision 4080)
@@ -38,11 +38,12 @@
 
 import org.w3c.dom.*;
 import org.xml.sax.*;
-import org.xml.sax.XMLReader;
 import org.xml.sax.helpers.XMLReaderFactory;
 
 import com.arbortext.catalog.*;
 
+import edu.ucsb.nceas.metacat.service.PropertyService;
+
 /**
  * Name: DBValidate.java
  *       Purpose: A Class that validates XML documents
@@ -70,7 +71,7 @@
     alreadyHandle = false;
     try {
       // Get an instance of the parser
-      String parserName = MetaCatUtil.getOption("saxparser");
+      String parserName = PropertyService.getProperty("saxparser");
       parser = XMLReaderFactory.createXMLReader(parserName);
       parser.setFeature("http://xml.org/sax/features/validation",true);
       //parser.setValidationMode(true);     // Oracle
@@ -227,7 +228,6 @@
 
     String doc = args[0];
 
-    MetaCatUtil util = new MetaCatUtil();
     DBConnection conn = null;
     int serailNumber = -1;
     try {
Index: src/edu/ucsb/nceas/metacat/SubTree.java
===================================================================
--- src/edu/ucsb/nceas/metacat/SubTree.java	(revision 4079)
+++ src/edu/ucsb/nceas/metacat/SubTree.java	(revision 4080)
@@ -36,6 +36,8 @@
 import org.apache.log4j.Logger;
 import org.xml.sax.SAXException;
 
+import edu.ucsb.nceas.metacat.util.MetaCatUtil;
+
 /**
  * A Class that represents an XML Subtree
  */
Index: src/edu/ucsb/nceas/metacat/advancedsearch/BrowseServlet.java
===================================================================
--- src/edu/ucsb/nceas/metacat/advancedsearch/BrowseServlet.java	(revision 4079)
+++ src/edu/ucsb/nceas/metacat/advancedsearch/BrowseServlet.java	(revision 4080)
@@ -37,7 +37,10 @@
 import javax.servlet.http.HttpSession;
 
 import edu.ucsb.nceas.metacat.client.*;
+import edu.ucsb.nceas.metacat.service.PropertyService;
+import edu.ucsb.nceas.metacat.util.SystemUtil;
 import edu.ucsb.nceas.utilities.Options;
+import edu.ucsb.nceas.utilities.PropertyNotFoundException;
 
 /** 
  * @author dcosta
@@ -107,28 +110,28 @@
   }
   
   /**
-   * Initializes the servlet. Reads properties and initializes object fields.
-   * 
-   * @throws ServletException
-   */
-  public void init(ServletConfig config) throws ServletException {
-	ServletContext context = null;
-    String dirPath;
-    Options options = null;
+	 * Initializes the servlet. Reads properties and initializes object fields.
+	 * 
+	 * @throws ServletException
+	 */
+	public void init(ServletConfig config) throws ServletException {
+		ServletContext context = null;
+		String dirPath;
+		Options options = null;
 
-    super.init(config);
-    context = config.getServletContext();
-    dirPath = context.getRealPath(CONFIG_DIR);
-    File propertyFile = new File(dirPath, CONFIG_NAME);
-    
-    try {
-      options = Options.initialize(propertyFile);
-    }
-    catch (IOException e) {
-      System.err.println("Error in loading options: " + e.getMessage());
-    }
-    
-    this.contextString = options.getOption("context");
-  }
+		super.init(config);
+		context = config.getServletContext();
+		dirPath = context.getRealPath(CONFIG_DIR);
+		File propertyFile = new File(dirPath, CONFIG_NAME);
 
+		try {
+			options = Options.initialize(propertyFile);
+			this.contextString = PropertyService.getProperty("application.context");
+		} catch (IOException e) {
+			System.err.println("Error in loading options: " + e.getMessage());
+		} catch (PropertyNotFoundException pnfe) {
+			System.err.println("couldn't read property during initialization: "
+					+ pnfe.getMessage());
+		}
+	}
 }
Index: lib/style/common/configure-check.jsp
===================================================================
--- lib/style/common/configure-check.jsp	(nonexistent)
+++ lib/style/common/configure-check.jsp	(revision 4080)
@@ -0,0 +1,36 @@
+<%@ page errorPage="jsperrorpage.html"%>
+<%@page import="edu.ucsb.nceas.metacat.util.MetaCatUtil"%>
+<%
+	 /**
+	 *   '$RCSfile$'
+	 *   Copyright: 2008 Regents of the University of California and the
+	 *              National Center for Ecological Analysis and Synthesis
+	 *
+	 *    '$Author$'
+	 *      '$Date$'
+	 *  '$Revision$'
+	 *
+	 * This program is free software; you can redistribute it and/or modify
+	 * it under the terms of the GNU General Public License as published by
+	 * the Free Software Foundation; either version 2 of the License, or
+	 * (at your option) any later version.
+	 *
+	 * This program is distributed in the hope that it will be useful,
+	 * but WITHOUT ANY WARRANTY; without even the implied warranty of
+	 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+	 * GNU General Public License for more details.
+	 *
+	 * You should have received a copy of the GNU General Public License
+	 * along with this program; if not, write to the Free Software
+	 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+	 */
+%>
+
+<%
+if (!MetaCatUtil.isMetacatConfigured()) {
+%>
+	<jsp:forward page="/metacat" />
+<%
+}
+%>
+

Index: src/upgrade_db_to_1_5.java
===================================================================
--- src/upgrade_db_to_1_5.java	(revision 4079)
+++ src/upgrade_db_to_1_5.java	(revision 4080)
@@ -33,14 +33,27 @@
 import java.sql.SQLException;
 import java.sql.DriverManager;
 
-import edu.ucsb.nceas.metacat.MetaCatUtil;
+import edu.ucsb.nceas.metacat.service.PropertyService;
+import edu.ucsb.nceas.utilities.PropertyNotFoundException;
 
 public class upgrade_db_to_1_5{
 
-    static String database = MetaCatUtil.getOption("databaseType");
-    static String url = MetaCatUtil.getOption("defaultDB");
-    static String user = MetaCatUtil.getOption("user");
-    static String password = MetaCatUtil.getOption("password");
+    static String database = null;
+    static String url = null;
+    static String user = null;
+    static String password = null;
+    static {
+    	try {
+    	    database = PropertyService.getProperty("database.type");
+    	    url = PropertyService.getProperty("database.connectionURI");
+    	    user = PropertyService.getProperty("database.user");
+    	    password = PropertyService.getProperty("database.password");
+    	} catch (PropertyNotFoundException pnfe) {
+            System.err.println("Error in upgrade_db_to_1_5 static block:"
+                    + pnfe.getMessage());
+            pnfe.printStackTrace();
+    	}
+     }
 
     public static void upgrade_xml_nodes(Connection sqlca) throws SQLException{
         Statement sqlStatement = null;
@@ -134,7 +147,7 @@
             Connection sqlca = null;
 
             // Create a JDBC connection to the database
-            if (database.equals("oracle") {
+            if (database.equals("oracle")) {
             	DriverManager.registerDriver(new oracle.jdbc.driver.OracleDriver());
             } 
             else if (database.equals("postgresql")) {
Index: src/upgrade-db-to-1.9.sql
===================================================================
--- src/upgrade-db-to-1.9.sql	(nonexistent)
+++ src/upgrade-db-to-1.9.sql	(revision 4080)
@@ -0,0 +1,23 @@
+/*
+ * db_version -- table to store the version history of this database
+ */
+CREATE TABLE db_version (
+  db_version_id   NUMBER(20),       -- the identifier for the version
+  version         VARCHAR(250),     -- the version number
+  status          NUMBER(20),       -- status of the version
+  date_created    DATE,             -- the datetime on which the version was created
+  CONSTRAINT db_version_pk PRIMARY KEY (db_version_id)
+);
+
+CREATE SEQUENCE db_version_id_seq;
+CREATE TRIGGER db_version_before_insert
+BEFORE INSERT ON db_version FOR EACH ROW
+BEGIN
+  SELECT db_version_id_seq.nextval
+    INTO :new.db_version_id
+    FROM dual;
+END;
+/
+
+INSERT INTO db_version (version, status, date_created) 
+  VALUES ('1.8.0', 1, CURRENT_DATE);

Index: src/loaddtd.sql
===================================================================
--- src/loaddtd.sql	(revision 4079)
+++ src/loaddtd.sql	(revision 4080)
@@ -3,34 +3,34 @@
         AND public_id LIKE '%@eml-version@%';
 INSERT INTO xml_catalog (entry_type, public_id, system_id)
   VALUES ('DTD', '-//ecoinformatics.org//eml-access-@eml-version@//EN',
-         '@systemidserver@@html-path@/dtd/eml-access-@eml-version@.dtd');
+         '/dtd/eml-access-@eml-version@.dtd');
 INSERT INTO xml_catalog (entry_type, public_id, system_id)
   VALUES ('DTD', '-//ecoinformatics.org//eml-attribute-@eml-version@//EN',
-          '@systemidserver@@html-path@/dtd/eml-attribute-@eml-version@.dtd');
+          '/dtd/eml-attribute-@eml-version@.dtd');
 INSERT INTO xml_catalog (entry_type, public_id, system_id)
   VALUES ('DTD', '-//ecoinformatics.org//eml-constraint-@eml-version@//EN',
-          '@systemidserver@@html-path@/dtd/eml-constraint-@eml-version@.dtd');
+          '/dtd/eml-constraint-@eml-version@.dtd');
 INSERT INTO xml_catalog (entry_type, public_id, system_id)
   VALUES ('DTD', '-//ecoinformatics.org//eml-coverage-@eml-version@//EN',
-          '@systemidserver@@html-path@/dtd/eml-coverage-@eml-version@.dtd');
+          '/dtd/eml-coverage-@eml-version@.dtd');
 INSERT INTO xml_catalog (entry_type, public_id, system_id)
   VALUES ('DTD', '-//ecoinformatics.org//eml-dataset-@eml-version@//EN',
-          '@systemidserver@@html-path@/dtd/eml-dataset-@eml-version@.dtd');
+          '/dtd/eml-dataset-@eml-version@.dtd');
 INSERT INTO xml_catalog (entry_type, public_id, system_id)
   VALUES ('DTD', '-//ecoinformatics.org//eml-entity-@eml-version@//EN',
-          '@systemidserver@@html-path@/dtd/eml-entity-@eml-version@.dtd');
+          '/dtd/eml-entity-@eml-version@.dtd');
 INSERT INTO xml_catalog (entry_type, public_id, system_id)
   VALUES ('DTD', '-//ecoinformatics.org//eml-literature-@eml-version@//EN',
-          '@systemidserver@@html-path@/dtd/eml-literature-@eml-version@.dtd');
+          '/dtd/eml-literature-@eml-version@.dtd');
 INSERT INTO xml_catalog (entry_type, public_id, system_id)
   VALUES ('DTD', '-//ecoinformatics.org//eml-physical-@eml-version@//EN',
-          '@systemidserver@@html-path@/dtd/eml-physical-@eml-version@.dtd');
+          '/dtd/eml-physical-@eml-version@.dtd');
 INSERT INTO xml_catalog (entry_type, public_id, system_id)
   VALUES ('DTD', '-//ecoinformatics.org//eml-project-@eml-version@//EN',
-          '@systemidserver@@html-path@/dtd/eml-project-@eml-version@.dtd');
+          '/dtd/eml-project-@eml-version@.dtd');
 INSERT INTO xml_catalog (entry_type, public_id, system_id)
   VALUES ('DTD', '-//ecoinformatics.org//eml-protocol-@eml-version@//EN',
-          '@systemidserver@@html-path@/dtd/eml-protocol-@eml-version@.dtd');
+          '/dtd/eml-protocol-@eml-version@.dtd');
 INSERT INTO xml_catalog (entry_type, public_id, system_id)
   VALUES ('DTD', '-//ecoinformatics.org//eml-software-@eml-version@//EN',
-          '@systemidserver@@html-path@/dtd/eml-software-@eml-version@.dtd');
+          '/dtd/eml-software-@eml-version@.dtd');
Index: src/upgrade-db-to-1.6-postgres.sql
===================================================================
--- src/upgrade-db-to-1.6-postgres.sql	(revision 4079)
+++ src/upgrade-db-to-1.6-postgres.sql	(revision 4080)
@@ -120,7 +120,7 @@
  * Delete the records from xml_index table which point to old revisions in xml_index
  * This is possible for documents for which the indexing thread failed during UPDATE
  */
-DELETE FROM xml_index WHERE nodeid = xml_nodes_revisions.nodeid;
+DELETE FROM xml_index WHERE nodeid IN (SELECT nodeid FROM xml_nodes_revisions);
 
 
 
Index: src/edu/ucsb/nceas/dbadapter/AbstractDatabase.java
===================================================================
--- src/edu/ucsb/nceas/dbadapter/AbstractDatabase.java	(revision 4079)
+++ src/edu/ucsb/nceas/dbadapter/AbstractDatabase.java	(revision 4080)
@@ -29,8 +29,9 @@
 package edu.ucsb.nceas.dbadapter;
 
 import java.sql.*;
-import edu.ucsb.nceas.metacat.MetaCatUtil;
 
+import edu.ucsb.nceas.metacat.service.PropertyService;
+
 /**
  * Java offers uniform database access through the use of JDBC.
  * But many databases still use different SQL implementations and 
@@ -136,7 +137,7 @@
     // Determine our db adapter class and
     // create an instance of that class
     try {
-      String dbAdapter = MetaCatUtil.getOption("dbAdapter");
+      String dbAdapter = PropertyService.getProperty("database.adapter");
       AbstractDatabase dbAdapterObj = (AbstractDatabase)createObject(dbAdapter);
       
       // test if they work correctly
